searchData={"items":[{"type":"module","title":"EctoPlaylist","doc":"Implements conveniences to handle the items order of a list.","ref":"EctoPlaylist.html"},{"type":"function","title":"EctoPlaylist.complete_order/2","doc":"Returns the list of ids composed of the current list order + all the missings ids ordered by insertion date.","ref":"EctoPlaylist.html#complete_order/2"},{"type":"function","title":"Examples - EctoPlaylist.complete_order/2","doc":"all_items = [%{id: 1, title: \"Item 1\", inserted_at: ~N[2019-07-16 16:03:15]},\n        %{id: 2, title: \"Item 2\", inserted_at: ~N[2019-07-16 16:04:15]},\n        %{id: 3, title: \"Item 3\", inserted_at: ~N[2019-07-16 16:05:15]},\n        %{id: 4, title: \"Item 4\", inserted_at: ~N[2019-07-16 16:06:15]},\n        %{id: 5, title: \"Item 5\", inserted_at: ~N[2019-07-16 16:07:15]}]\n\n    order = [5, 3, 1]\n\n    complete_order(all_items, order)\n    # [5, 3, 1, 2, 4]","ref":"EctoPlaylist.html#complete_order/2-examples"},{"type":"function","title":"EctoPlaylist.missing_ids_list/1","doc":"Same as `missing_ids_list/2` but returns all ids ordered by insertion date.","ref":"EctoPlaylist.html#missing_ids_list/1"},{"type":"function","title":"EctoPlaylist.missing_ids_list/2","doc":"Returns the list of missing ids ordered by insertion date.","ref":"EctoPlaylist.html#missing_ids_list/2"},{"type":"function","title":"Examples - EctoPlaylist.missing_ids_list/2","doc":"all_items = [%{id: 1, title: \"Item 1\", inserted_at: ~N[2019-07-16 16:03:15]},\n        %{id: 2, title: \"Item 2\", inserted_at: ~N[2019-07-16 16:04:15]},\n        %{id: 3, title: \"Item 3\", inserted_at: ~N[2019-07-16 16:05:15]},\n        %{id: 4, title: \"Item 4\", inserted_at: ~N[2019-07-16 16:06:15]},\n        %{id: 5, title: \"Item 5\", inserted_at: ~N[2019-07-16 16:07:15]}]\n\n    order = [5, 3, 1]\n\n    missing_ids_list(all_items, order)\n    # [2, 4]","ref":"EctoPlaylist.html#missing_ids_list/2-examples"},{"type":"function","title":"EctoPlaylist.ordered_items_list/2","doc":"Returns the list of items ordered according to the order list.\n\nIf ids are missing in order, the items will be ordered according to their inserted date.","ref":"EctoPlaylist.html#ordered_items_list/2"},{"type":"function","title":"Examples - EctoPlaylist.ordered_items_list/2","doc":"all_items = [%{id: 1, title: \"Item 1\", inserted_at: ~N[2019-07-16 16:03:15]},\n        %{id: 2, title: \"Item 2\", inserted_at: ~N[2019-07-16 16:04:15]},\n        %{id: 3, title: \"Item 3\", inserted_at: ~N[2019-07-16 16:05:15]},\n        %{id: 4, title: \"Item 4\", inserted_at: ~N[2019-07-16 16:06:15]},\n        %{id: 5, title: \"Item 5\", inserted_at: ~N[2019-07-16 16:07:15]}]\n\n    order = [5, 3, 1]\n\n    ordered_items_list(all_items, order)\n    # [%{id: 5, title: \"Item 5\", inserted_at: ~N[2019-07-16 16:07:15]},\n    #    %{id: 3, title: \"Item 3\", inserted_at: ~N[2019-07-16 16:05:15]},\n    #    %{id: 1, title: \"Item 1\", inserted_at: ~N[2019-07-16 16:03:15]},\n    #    %{id: 2, title: \"Item 2\", inserted_at: ~N[2019-07-16 16:04:15]},\n    #    %{id: 4, title: \"Item 4\", inserted_at: ~N[2019-07-16 16:06:15]}]","ref":"EctoPlaylist.html#ordered_items_list/2-examples"},{"type":"module","title":"EctoPlaylist.Context","doc":"Implements conveniences to manipulate the items order list.\n\nYou can implement all the functions available in this module by using this module inside of the context of\nthe List module.\n(Check the guides to see how)\n\nThere are two functions in this module: `sync_order_list/1` and `reset_order_list/1`\n\nThey both take a `List` struct that you define when calling \"use\".\n\n`sync_order_list/1` : will add missing ids to the items order list of the list.\n\n`reset_order_list/1` : will set the items order as the list of ids ordered by inserted date.","ref":"EctoPlaylist.Context.html"},{"type":"module","title":"EctoPlaylist.ListItem","doc":"","ref":"EctoPlaylist.ListItem.html"},{"type":"function","title":"EctoPlaylist.ListItem.insert_at/3","doc":"","ref":"EctoPlaylist.ListItem.html#insert_at/3"},{"type":"function","title":"EctoPlaylist.ListItem.insert_at_reject/3","doc":"","ref":"EctoPlaylist.ListItem.html#insert_at_reject/3"},{"type":"function","title":"EctoPlaylist.ListItem.lower_item/2","doc":"","ref":"EctoPlaylist.ListItem.html#lower_item/2"},{"type":"function","title":"EctoPlaylist.ListItem.move_higher/2","doc":"","ref":"EctoPlaylist.ListItem.html#move_higher/2"},{"type":"function","title":"EctoPlaylist.ListItem.move_lower/2","doc":"","ref":"EctoPlaylist.ListItem.html#move_lower/2"},{"type":"function","title":"EctoPlaylist.ListItem.move_to_bottom/2","doc":"","ref":"EctoPlaylist.ListItem.html#move_to_bottom/2"},{"type":"function","title":"EctoPlaylist.ListItem.move_to_top/2","doc":"","ref":"EctoPlaylist.ListItem.html#move_to_top/2"},{"type":"function","title":"EctoPlaylist.ListItem.remove_from_list/2","doc":"","ref":"EctoPlaylist.ListItem.html#remove_from_list/2"},{"type":"extras","title":"ecto_playlist","doc":"# ecto_playlist\n\nEcto_playlist is a simple library that helps you manage ordered model with Ecto.","ref":"readme.html"},{"type":"extras","title":"Description - ecto_playlist","doc":"Let's take an example of an ordered model: a Playlist which contains an ordered list of Schemes.\n\nInstead of storing the position of each scheme in the schemes themselves, we will store the ordering in the playlist and we will call `EctoPlaylist.ordered_items_list/2` to return for us the list of items properly ordered.","ref":"readme.html#description"},{"type":"extras","title":"Installation - ecto_playlist","doc":"Read the [tutorial](guides/tutorial.md) to understand the process of installation of the library.","ref":"readme.html#installation"},{"type":"extras","title":"Functions available - ecto_playlist","doc":"In `EctoPlaylist.ListItem`, you have a set of functions to modify the ordering of your order list.\n\n#### Functions That Change Position and Reorder List\n\n- `EctoPlaylist.ListItem.insert_at/3`\n- `EctoPlaylist.ListItem.move_lower/2` will do nothing if the item is the lowest item\n- `EctoPlaylist.ListItem.move_higher/2` will do nothing if the item is the highest item\n- `EctoPlaylist.ListItem.move_to_bottom/2`\n- `EctoPlaylist.ListItem.move_to_top/2`\n- `EctoPlaylist.ListItem.remove_from_list/2`\n\n#### Methods That Return Data of the Item's List Position\n\n- `EctoPlaylist.ListItem.first?/2`\n- `EctoPlaylist.ListItem.last?/2`\n- `EctoPlaylist.ListItem.in_list?/2`\n- `EctoPlaylist.ListItem.not_in_list?/2`\n- `EctoPlaylist.ListItem.higher_item/2`\n- `EctoPlaylist.ListItem.higher_items/2` will return all the ids above the given list item id in the order_list\n- `EctoPlaylist.ListItem.lower_item/2`\n- `EctoPlaylist.ListItem.lower_items/2` will return all the ids below the given list item id in the order_list","ref":"readme.html#functions-available"},{"type":"extras","title":"Documentation - ecto_playlist","doc":"The documentation can be found here: [https://hexdocs.pm/ecto_playlist](https://hexdocs.pm/ecto_playlist).","ref":"readme.html#documentation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}